/*
  ratbot-slam (c) 2006 Kris Beevers

  This file is part of ratbot-slam.

  ratbot-slam is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  ratbot-slam is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with ratbot-slam; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
  USA
*/

#include <stdio.h>
#include <math.h>
#include <fixedpoint.h>
#include "ratbot-slam.h"

int main()
{
  FILE *out = fopen("unit_gaussian_table.c", "w");
  fprintf(out, "#include <fixedpoint.h>\n\n");
  fprintf(out, "fixed_t unit_gaussian_table[] PROGMEM = {\n  ");
  fixed_t f = 0;
  int count = 1;
  for(; f <= fp_1; f += 1 << unit_gaussian_shift, ++count) {
    float fl = fp2float(f);
    float g = sqrt(-2.0 * log(fl) / fl);
    fixed_t fpl = float2fp(g);
    if(fpl < 0) fpl = fp_max_value;
    fprintf(out, "%d, ", fpl);
    if(count % 12 == 0)
      fprintf(out, "\n  ");
  }
  fprintf(out, "\n};\n");
  fclose(out);
  return 0;
}
