function [u,P]=motion_model(L,R,sigma,u_prev,P_prev)
c=0.0001994175025;
b=0.119;
u=u_prev + [((c*L+c*R)/2)*cos(u_prev(3)+(c*L-c*R)/(2*b));
            ((c*L+c*R)/2)*sin(u_prev(3)+(c*L-c*R)/(2*b));
            (c*L-c*R)/(2*b)];

Pu=[(sigma*L)^2, 0; 0, (sigma*R)^2];
Jx=[1,0,-0.5*(c*L+c*R)*sin(u_prev(3)+(c*L-c*R)/(2*b));
    0,1,0.5*(c*L+c*R)*cos(u_prev(3)+(c*L-c*R)/(2*b));
    0,0,1];
T1=0.5*c*cos(u(3));
T2=0.25*c*sin(u(3))*(c*L+c*R)/b;
T3=0.5*c*sin(u(3));
T4=0.25*c*cos(u(3))*(c*L+c*R)/b;
Ju=[T1-T2, T1+T2; T3+T4, T3-T4; c/(2*b), -c/(2*b)];
P=Jx*P_prev*Jx' + Ju*Pu*Ju';