function [e]=nees(pfn,tfn)
p=load(pfn);
N=size(p,2)/4;
t=load(tfn);
k=min(size(t,1),size(p,1));

warning off all;

for i=1:k
    % compute distribution for the particle set at time k
    
    % mean
    ux=0; uy=0; ust=0; uct=0; W=0;
    for j=1:N
        pji=[p(i,(j-1)*4+1),p(i,(j-1)*4+2),p(i,(j-1)*4+3)];
        w=p(i,(j-1)*4+4);
        ux=ux+pji(1)*w;
        uy=uy+pji(2)*w;
        ust=ust+sin(pji(3))*w;
        uct=uct+cos(pji(3))*w;
        W=W+w;
    end
    ut=atan2(ust/W,uct/W);
    ux=ux/W;
    uy=uy/W;
    
    % covariance
    xx=0; xy=0; xt=0; yy=0; yt=0; tt=0;
    for j=1:N
        pji=[p(i,(j-1)*4+1),p(i,(j-1)*4+2),p(i,(j-1)*4+3)];
        w=p(i,(j-1)*4+4);
        dx=pji(1)-ux;
        dy=pji(2)-uy;
        dt=pi_to_pi(pji(3)-ut); % FIXME angular distance?
        xx=xx+dx*dx*w/W;
        xy=xy+dx*dy*w/W;
        xt=xt+dx*dt*w/W;
        yy=yy+dy*dy*w/W;
        yt=yt+dy*dt*w/W;
        tt=tt+dt*dt*w/W;
    end
        
    % compute squared mahalanobis distance of t(k) wrt distribution
    cov=[xx,xy,xt; xy,yy,yt; xt,yt,tt];
    nu=[t(i,1)-ux; t(i,2)-uy; pi_to_pi(t(i,3)-ut)];
    e(i)=nu'*inv(cov)*nu;
end