function niceplot(D,xrange,yrange,ratio,plotone,ylab)

if nargin < 2
    xrange=[1 length(D)];
end
if nargin < 3
    yrange=[min(D(xrange(1):xrange(2))) max(D(xrange(1):xrange(2)))];
    if(yrange(1) > 0)
        yrange(1)=0;
    end
    if isnan(yrange(1))
        yrange(1)=-Inf;
    end
    if isnan(yrange(2))
        yrange(2)=Inf;
    end
end
if nargin < 4
    ratio = 6;
%    ratio = 12;
end

for i=1:length(D)
    if isinf(D(i)) | isnan(D(i))
        D(i)=yrange(2)+1;
    end
end

figure
area(D,'EdgeColor','k','FaceColor',[0.7 0.7 0.7]), hold on
axis([xrange(1) xrange(2) yrange(1) yrange(2)])
if nargin >= 6
    ylabel(ylab)
end
set(gca,'ytick',[yrange(1) yrange(2)])
%set(gca,'xtick',[xrange(1) xrange(2)])
set(gca,'xtick',[])
pbaspect([ratio 1 1])

if nargin >= 5
    l(xrange(1):xrange(2))=1;
    plot(l,'k-')
end