/*
  ratbot-slam (c) 2006 Kris Beevers

  This file is part of ratbot-slam.

  ratbot-slam is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  ratbot-slam is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with ratbot-slam; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301
  USA
*/

// this is a driver program for ratbot-slam that runs slam onboard the
// ratbot in real time.

#include "ratbot-slam.h"
#include <stdlib.h>
#include "uart.h"
#include "rprintf.h"
#include "timer128.h"
#include "global.h"
#include "a2d.h"
#include "util.h"
#include "spi.h"
#include "led.h"
//#include "radio.h"
//#include "radio_cmd.h"
//#include "comm.h"
//#include "rf_checksum.h"
//#include "remote.h"
#include "motor.h"
#include "sensor.h"
#include "rprintf.h"

void extmem_init (void) __attribute__ ((naked)) \
   __attribute__ ((section (".init3")));
void extmem_init (void)
{
  MCUCR = 0x80; // enable memory interface
}

int main(void)
{
  timerInit();
  ledInit();
  a2dInit();

  ledBlink(8,1);

  spi_init();
  motor_init();
  ir_init();
  ledBlink(4,1);

  uartInit();
  uartSetBaudRate(9600);
  rprintfInit((void *)uart_putc);

  ledBlink(2,1);

  //  remote_init();

  srand(readIR(IR_FRONT));

  pose_t start;
  start.x = start.y = start.t = 0;

  filter_init(&start);

  encData enc;
  int16_t ranges[5];
  while(1) {
    enc = getEnc();
    ranges[0] = readIR(IR_RIGHT);
    ranges[1] = readIR(IR_RIGHTFRONT);
    ranges[2] = readIR(IR_FRONT);
    ranges[3] = readIR(IR_LEFTFRONT);
    ranges[4] = readIR(IR_LEFT);

    // FIXME: we really want a much better way to manage this, i.e.,
    // we'd like to be able to collect data at reasonably fixed
    // intervals while running the slam update in the background.
    // this can probably be done with interrupts.

    filter_update(enc.left, enc.right, ranges);

    //    while(radio_num_packets() > 0)
    //      handle_incoming();
  }

  return 0;
}
